import javax.swing.JPanel;
import java.awt.event.*;
import java.awt.event.MouseAdapter;
import java.awt.geom.Point2D;

public class MouseListener extends MouseAdapter {
   private MyWorld world;
   private Drawable currentElement;
   private JPanel panel;
   public MouseListener (MyWorld w, JPanel p){
      world = w;
      panel = p;
   } 
   public void mouseMoved(MouseEvent e) {
      Point2D.Double p = new Point2D.Double(0,0);
      MyWorld.SPACE_INVERSE_TRANSFORM.transform(e.getPoint(),p);
      Drawable newElement = world.find(p.getX(), p.getY());
      if (newElement == currentElement) return;
      if (currentElement != null) {
         currentElement.setReleased();
         currentElement = null;
      }
      if (newElement != null) { 
         currentElement = newElement;
         currentElement.setSelected();
      }
      panel.repaint();
   }
   public void mouseDragged(MouseEvent e) {
      Point2D.Double p = new Point2D.Double(0,0);
      MyWorld.SPACE_INVERSE_TRANSFORM.transform(e.getPoint(),p);
      if (currentElement == null) return;
      currentElement.dragTo(p.getX(), p.getY());
      panel.repaint();
   }
   public void mouseReleased(MouseEvent e) {
      if (currentElement != null) 
         currentElement.setReleased();
   }
}