import javax.swing.JFrame;
import javax.swing.*;

public class PhysicsLab {
	public static void main(String[] args) {
		PhysicsLabFrame labFrame = new PhysicsLabFrame();
		labFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		labFrame.setVisible(true);
	}
}

class PhysicsLabFrame extends JFrame {
	public PhysicsLabFrame() {
		setTitle("Small Physics Laboratory");
		setSize(MyWorld.WIDTH, MyWorld.HEIGHT+50);
		MyWorld world = new MyWorld();
		PhysicsLabPanel labPanel = new PhysicsLabPanel(world);
		add(labPanel);  // it is equivalent to getContentPane().add(...);
		world.setPanel(labPanel);   // to repaint view when model changes
		ElementMenuListener cListener = new ElementMenuListener(world);
		WorldControlMenuListener wcListener = new WorldControlMenuListener(world);
		JMenuBar menuBar = createLabMenuBar(cListener, wcListener);
		setJMenuBar(menuBar);
	}

	private JMenuBar createLabMenuBar(ElementMenuListener cl, WorldControlMenuListener wl) {
		JMenuBar mb = new JMenuBar();

		JMenu menu = new JMenu ("Element");
		mb.add(menu);
		JMenu subMenu = new JMenu("Insert");  
		menu.add(subMenu);

		JMenuItem menuItem = new JMenuItem("Ball");
		menuItem.addActionListener(cl);
		subMenu.add(menuItem);
		menuItem = new JMenuItem("Wall Sideways");
		menuItem.addActionListener(cl);
		subMenu.add(menuItem);
		menuItem = new JMenuItem("Wall Straight");
		menuItem.addActionListener(cl);
		subMenu.add(menuItem);
		
		menuItem = new JMenuItem("Scenario");
		menuItem.addActionListener(cl);
		subMenu.add(menuItem);

		menu = new JMenu("MyWorld");
		mb.add(menu);
		menuItem = new JMenuItem("Start");
		menuItem.addActionListener(wl);
		menu.add(menuItem);
		menuItem = new JMenuItem("Stop");
		menuItem.addActionListener(wl);
		menu.add(menuItem);
		menuItem = new JMenuItem("Gravity");
		menuItem.addActionListener(wl);
		menu.add(menuItem);
		menuItem = new JMenuItem("Viscosity");
		menuItem.addActionListener(wl);
		menu.add(menuItem);
		subMenu = new JMenu("Simulator");
		menu.add(subMenu);
		menuItem = new JMenuItem("Delta time");
		menuItem.addActionListener(wl);
		subMenu.add(menuItem);
		menuItem = new JMenuItem("Graphics Refresh time");
		menuItem.addActionListener(wl);
		subMenu.add(menuItem);
		return mb;          
	}   
}
